#include <iostream>

using namespace std;


int main()
{
    int n,q,l,r,br=0;
    cin >> n >> q;
    int A[n];
    int odg[q];
    for(int i=0;i<n;i++)
        cin >> A[i];
    for(int i=0;i<q;i++)
    {
        cin >> l >> r;
        for(int j=l;j<=r;j++)
            if(j==1)
                br++;
        if(br==(r-l)+1)
            odg[i]=1;
        else
            odg[i]=0;
    }
    for(int i=0;i<q;i++)
        cout << odg[i] << endl;
    return 0;
}